#pragma once

#include <math.h>
#include "rgba32.h"

static __host__ __device__ rgba32 color_1d(float v) {
    rgba32 c = {255U, 255U, 255U, 255U}; // white
    if (v < 0.25f) {
        c.r = 0;
        c.g = (char) rintf(1020.0f * v);
    } else if (v < 0.5f) {
        c.r = 0;
        c.b = (char) rintf(255.0f * (1.0f + 4.0f * (0.25f - v)));
    } else if (v < 0.75f) {
        c.r = (char) rintf(1020.0f * (v - 0.5f));
        c.b = 0;
    } else {
        c.g = (char) rintf(255.0f * (1.0f + 4.0f * (0.75f - v)));
        c.b = 0;
    }
    return c;
}

static __host__ __device__ rgba32 color_2d(float x, float y) {
    rgba32 c;
    c.r = (char) rintf(255.0f * x);
    c.g = (char) rintf(255.0f * y);
    c.b = (char) rintf(127.5f * x + 127.5f * y);
    return c;
}
